import Foundation
import UIKit
import Family

class BlueViewController: UIViewController {
    override func viewDidLoad() {
        super.viewDidLoad()

        view.backgroundColor = .blue
    }
}

class RedViewController: UIViewController {
    override func viewDidLoad() {
        super.viewDidLoad()

        view.backgroundColor = .red
    }
}

class MyViewController: FamilyViewController {
    override func viewDidLoad() {
        super.viewDidLoad()

        view.backgroundColor = .white
        title = "Test family"

        let blueViewController = BlueViewController()
        addChild(blueViewController, height: 100)

        let redViewController = RedViewController()
        addChild(redViewController, height: 100)
    }

    override func viewDidAppear(_ animated: Bool) {
        super.viewDidAppear(animated)

        let deadlineTime = DispatchTime.now() + .seconds(3)
        DispatchQueue.main.asyncAfter(deadline: deadlineTime) {
            self.performBatchUpdates({ (controller) in
                self.children.first?.removeFromParent()
            })
        }

    }
}
